/*
 * AccessorUnknownExceptionTest.java
 * Copyright (C) 2008 Cyber Beans Corporation. All rights reserved.
 */
package jp.co.cybec.cb3.exception;

import jp.co.cybec.cb3.exception.AccessorUnknownException;
import junit.framework.Assert;
import org.junit.Test;

/**
 * AccessorUnknownExceptionのテストケース。
 * @author Naoko Sugimoto
 */
public class AccessorUnknownExceptionTest {

	/**
	 * {@link jp.co.cybec.cb3.exception.AccessorUnknownException#AccessorUnknownException(java.lang.Exception)} のためのテスト・メソッド。
	 */
	@Test
	public void testConstructorWithException() {
		// 元になる例外を生成。
		String causeMessage = "XXXXに失敗しました。";
		Exception causeException = new Exception(causeMessage);

		// AccessorUnknownExceptionを生成。
		AccessorUnknownException newException = new AccessorUnknownException(causeException);

		// 元になった例外を保持していることを確認。
		Assert.assertSame(causeException, newException.getCause());
		// メッセージ内容を確認。
		Assert.assertEquals(0, newException.getMessage().indexOf(causeMessage));
	}

	/**
	 * {@link jp.co.cybec.cb3.exception.AccessorUnknownException#AccessorUnknownException(java.lang.String)} のためのテスト・メソッド。
	 */
	@Test
	public void testConstructorWithString() {
		String message = "XXXXに失敗しました。";

		// AccessorUnknownExceptionを生成。
		AccessorUnknownException newException = new AccessorUnknownException(message);

		// メッセージ内容を確認。
		Assert.assertEquals(message, newException.getMessage());
	}

	/**
	 * {@link jp.co.cybec.cb3.exception.AccessorUnknownException#AccessorUnknownException(java.lang.String, java.lang.Exception)} のためのテスト・メソッド。
	 */
	@Test
	public void testConstructorWithStringAndException() {
		// 元になる例外を生成。
		String causeMessage = "XXXXに失敗しました。";
		Exception causeException = new Exception(causeMessage);
		// 新しく追加するメッセージ。
		String newMessage = "YYYYの処理中に例外が発生しました。";

		// AccessorUnknownExceptionを生成。
		AccessorUnknownException newException = new AccessorUnknownException(newMessage, causeException);

		// 元になった例外を保持していることを確認。
		Assert.assertSame(causeException, newException.getCause());
		// メッセージ内容を確認。
		Assert.assertEquals(0, newException.getMessage().indexOf(newMessage));
	}

}
